/*
  type  //1-go,2-property,3-station,4-utility,5-Chance,6-Commu chest,7-Tax,8-Jail,9-Parking.
  name  //name of place
  cost  //price for the type if any
  rent  //rent on place if any
  owner //0-bank,1to4 player id 
 */

#include <stdio.h>
#include<stdlib.h>
#include<time.h>
#include<string.h>

// DATA ABOUT THE BOARD
//this array holds types like property, station etc
int type[24] = {1,2,2,4,5,3,2,2,9,3,2,6,8,2,7,3,2,4,5,2,6,3,2,7};
//this array holds names for each place on board
char *name[24] = {"Go","Kent Road","Whitechapel Raod","Electrical Company","Chance","King's Cross Station","Euston Road","Pentonville Road","Free Parking","Liverpool Street Station","Fleet Street","Community Chest","Jail","Strand","Income Tax", "Fenchurch Station","Whitehall","Water Works","Chance","Pall Mall","Community Chest","Marylebone Station","Vine Street","Super Tax"};
//this array holds cost if any
int cost[24] = {200, 60, 80, 150, 0, 200, 100, 120, 0, 200, 220, 0, 0, 220, 100, 200, 140, 150, 0, 140, 0, 200, 200, 150};
//this array holds rent if any
int rent[24] = {0, 8, 10, 0, 0, 0,10, 12, 0, 0, 22, 0, 0, 22, 0, 0, 14, 0, 0, 14, 0, 0, 20, 0};
//this array holds owner id if any
int owner[24] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};


// STRUCTURE OF THE PLAYER
struct user
{
  int id;
  char name[15];
  int balance;
  int place; 
  int totalproperty;
  int totalstation;
  int totalutility;
};
struct user *player[4];

// Display starting status of the board
void display_board()
{
  int i = 0;
  printf("\nPlace\tType\tCost\tRent\tOwner\tName\n");
  while(i < 24)
    {      
      //send all this info to client
      printf("%d)\t",i+1);
      printf("%d\t",type[i]);
      printf("%d\t",cost[i]);
      printf("%d\t",rent[i]);
      printf("%d\t",owner[i]);
      printf("%s\n",name[i]);
      i++;
    }  
}

// Display player status 
void display_player(int playerID)
{
  if(player[playerID-1]==NULL)
    printf("\nInvalid Player ID\n");
  else
    {
      printf("\nID\tName\tBalance\tPlace\n");
      //send all this info to client
      printf("%d\t",player[playerID-1]->id);
      printf("%s\t",player[playerID-1]->name);
      printf("%d\t",player[playerID-1]->balance);
      printf("%d\n",player[playerID-1]->place);
    }
}  

// Display All players status 
void display_allplayer()
{
  int i;
  printf("\nID\tName\tBalance\tPlace\n");
  for(i=0;i<4;i++)
    {
      if(player[i]==NULL)
	printf("\nplayer ID\n");
      else
	{
	  //send all this info to client
	  printf("%d\t",player[i]->id);
	  printf("%s\t",player[i]->name);
	  printf("%d\t",player[i]->balance);
	  printf("%d\n",player[i]->place);
	}
    }  
}


// Chance list
void chance(int roll,int playerID)
{  
  switch(roll)
    {
    case 7:
      printf("\nSpeeding fine Rs. 20/-"); //send this to client
      player[playerID-1]->balance -= 20;
      break;
    case 2: case 8:
      printf("\nBank pays you dividend of Rs. 50/-");
      player[playerID-1]->balance += 50;
      break;
    case 3: case 9:
      printf("\nPay school fees of Rs. 150/-");
      player[playerID-1]->balance -= 150;
      break;
    case 4: case 10:
      printf("\nGo to jail and pay fine Rs. 50/-");
      player[playerID-1]->balance -= 50;
      player[playerID-1]->place = 13;
      break;
    case 5: case 11:
      printf("\nYou have won a crossword competition collect Rs. 100/-");
      player[playerID-1]->balance += 100;
      break;
    case 6: case 12:
      printf("\nIncome tax Rs. 50/-");
      player[playerID-1]->balance -= 50;
      break;
    }  
}

// community chest list
void community_chest(int roll,int playerID)
{
  switch(roll)
    {
    case 7:
      printf("\nBank error in your favour. Collect Rs. 200/-");//send this to client
      player[playerID-1]->balance += 200;
      break;
    case 2: case 8:
      printf("\nPay hospital Rs. 100/-");
      player[playerID-1]->balance -= 100;
      break;
    case 3: case 9:
      printf("\nPay your insurance premium Rs. 50/-");
      player[playerID-1]->balance -= 50;
      break;
    case 4: case 10:
      printf("\nDoctor's Fee. Pay Rs. 50/-");
      player[playerID-1]->balance -= 50;
      break;
    case 5: case 11:
      printf("\nIt is your b'day collect Rs. 100/-");
      player[playerID-1]->balance += 100;
      break;
    case 6: case 12:
      printf("\nIncome tax refund. Collect Rs. 20/-");
      player[playerID-1]->balance += 20;
      break;
    }  
}
